//Code based on the "RDK Basic" design provided by Digilent


#if !defined(_MTRCTRL_INC)
#define _MTRCTRL_INC

#include "config.h"
#include "stdtypes.h"


#define	dtcMtrSlow		2500
#define	dtcMtrMedium	4000
#define	dtcMtrFast		8000
#define	dtcMtrStopped	0

/*	Motor feedback timing.
*/
#define	tusMtrFbSlow	8000
#define	tusMtrFbMedium	4000
#define	tusMtrFbFast	2500   

/*	Motor direction.
*/
#define	dirMtrLeftFwd	1
#define	dirMtrLeftBwd	0
#define	dirMtrRightFwd	0
#define	dirMtrRightBwd	1


/*	Motor control variables.
*/
volatile	BOOL	fMtrLeft;
volatile	BOOL	fMtrRight;
			HWORD	dtcMtrLeft;
			HWORD	dtcMtrRight;
			BYTE	dirMtrLeft;
			BYTE	dirMtrRight;



#define MtrCtrlFwd()		dirMtrLeft			= dirMtrLeftFwd;\
							dirMtrRight			= dirMtrRightFwd;\
							dtcMtrLeft			= dtcMtrFast+2000;\
							dtcMtrRight			= dtcMtrFast-3100
							
#define MtrCtrlFwdLeft()	dirMtrLeft			= dirMtrLeftFwd;\
							dirMtrRight			= dirMtrRightFwd;\
							dtcMtrLeft			= dtcMtrMedium;\
							dtcMtrRight			= dtcMtrFast
						
#define MtrCtrlFwdRight()	dirMtrLeft			= dirMtrLeftFwd;\
							dirMtrRight			= dirMtrRightFwd;\
							dtcMtrLeft			= dtcMtrFast;\
							dtcMtrRight			= dtcMtrMedium
							
#define MtrCtrlBwd()		dirMtrLeft			= dirMtrLeftBwd;\
							dirMtrRight			= dirMtrRightBwd;\
							dtcMtrLeft			= dtcMtrFast+2000;\
							dtcMtrRight			= dtcMtrFast-3100
							
#define MtrCtrlBwdLeft()	dirMtrLeft			= dirMtrLeftBwd;\
							dirMtrRight			= dirMtrRightBwd;\
							dtcMtrLeft			= dtcMtrSlow;\
							dtcMtrRight			= dtcMtrFast
						
#define MtrCtrlBwdRight()	dirMtrLeft			= dirMtrLeftBwd;\
							dirMtrRight			= dirMtrRightBwd;\
							dtcMtrLeft			= dtcMtrFast;\
							dtcMtrRight			= dtcMtrSlow
							
#define MtrCtrlLeft()		dirMtrLeft			= dirMtrLeftBwd;\
							dirMtrRight			= dirMtrRightFwd;\
							dtcMtrLeft			= dtcMtrFast+2000;\
							dtcMtrRight			= dtcMtrFast-3100

#define MtrCtrlRight()		dirMtrLeft			= dirMtrLeftFwd;\
							dirMtrRight			= dirMtrRightBwd;\
							dtcMtrLeft			= dtcMtrFast+2000;\
							dtcMtrRight			= dtcMtrFast-3100
							
#define	MtrCtrlStop()		dtcMtrLeft			= dtcMtrStopped;\
							dtcMtrRight			= dtcMtrStopped



void UpdateMotors();



#endif

