//Code based on the "PIC32_I2C_CodeExample" available on the Microchip website


#include <plib.h>


void Write(BYTE dat, BYTE addr)
	{
	unsigned char SlaveAddress;
	char i2cData[10];
	int DataSz;
	SlaveAddress=0b1101111;
    // Send Data to rtcc to program one location
i2cData[0] = (SlaveAddress << 1) | 0;//rtcc Device Address and WR Command
i2cData[1] = addr;
i2cData[2] = dat;
//i2cData[3] = 0x10;//data to write

DataSz = 3;
StartI2C1();//Send the Start Bit
IdleI2C1();//Wait to complete
int Index = 0;

while( DataSz )
{
MasterWriteI2C1( i2cData[Index++] );
IdleI2C1();//Wait to complete
DataSz--;


//ACKSTAT is 0 when slave acknowledge. if 1 then slave has not acknowledge
//the data.
if( I2C1STATbits.ACKSTAT )
break;
}

StopI2C1();//Send the Stop condition
IdleI2C1();//Wait to complete
// wait for rtcc to complete write process. poll the ack status

while(1)
{
i2c_wait(10);
StartI2C1();//Send the Start Bit
IdleI2C1();//Wait to complete
MasterWriteI2C1( i2cData[0] );
IdleI2C1();//Wait to complete
if( I2C1STATbits.ACKSTAT == 0 )//rtcc has acknowledged
{
StopI2C1();//Send the Stop condition
IdleI2C1();//Wait to complete

break;
}
StopI2C1();//Send the Stop condition
IdleI2C1();//Wait to complete
}
}//end Write



BYTE Read (BYTE addr)
	{
	unsigned char SlaveAddress;
	char i2cData[10];
	int DataSz;
	SlaveAddress=0b1101111;
	int Index = 0;
// Now Readback the data from the rtcc
i2cData[0] = (SlaveAddress << 1) | 0;//rtcc Device Address and WR Command
//(to write the address)
i2cData[1] = addr;
//i2cData[2] = 0x30;//rtcc location to read (low address byte)
DataSz = 2;
StartI2C1();//Send the Start Bit
IdleI2C1();//Wait to complete
//send the address to read from the rtcc
Index = 0;


while( DataSz )
{
MasterWriteI2C1( i2cData[Index++] );
IdleI2C1();//Wait to complete
DataSz--;
//ACKSTAT is 0 when slave acknowledge. if 1 then slave has not acknowledge
//the data.
if( I2C1STATbits.ACKSTAT )
break;
}

//now send a start sequence again
RestartI2C1();//Send the Stop condition
IdleI2C1();//Wait to complete
MasterWriteI2C1( (SlaveAddress << 1) | 1 ); //transmit read command
IdleI2C1();//Wait to complete
unsigned char i2cbyte;
i2cbyte = MasterReadI2C1();
StopI2C1();//Send the Stop condition
IdleI2C1();//Wait to complete


	return i2cbyte;
}// end Read

