//Code based on the "RDK Basic" design provided by Digilent

#include <plib.h>
#include "config.h"
#include "spi.h"


void SpiInit()
{
	// Configure SS pin as digital output.
	trisSpiSsClr = ( 1 << bnSpiSs );
	
	// Default SS pin to disabled.
	prtSpiSsSet = ( 1 << bnSpiSs );
	
	/* Implementation using SPI2 hardware interface.
	*/
	
	SPI2BRG = 7;	// Fsck = 500 KHz assuming Fpb = 10 MHz
	SPI2CON = ( 1 << bnSpi2On ) | ( 1 << bnSpi2Smp ) | ( 1 << bnSpi2Cke ) | ( 1 << bnSpi2Msten );
}


void SpiEnable()
{
	prtSpiSsClr = ( 1 << bnSpiSs );
}


void SpiDisable()
{
	prtSpiSsSet = ( 1 << bnSpiSs );
}


BYTE BSpiPutByte( BYTE bSnd )
{


	SPI2BUF = bSnd;	// write transmit data to buffer
	
//	 Wait for receive buffer to become filled.
	while ( ! (SPI2STAT & ( 1 << bnSpi2Spirbf )) ) {
		asm volatile("nop");
	}
	
	return SPI2BUF;


}



void SpiPutBuff( BYTE* pbBuff, WORD cbBuff )
{
	
    while ( 0 < cbBuff ) {
        BSpiPutByte(*pbBuff);
        pbBuff++;
        cbBuff--;
    }
}


void SpiGetBuff( BYTE bFill, BYTE* pbBuff, WORD cbBuff )
{
    while ( 0 < cbBuff ) {
        *pbBuff = BSpiPutByte(bFill);
        pbBuff++;
        cbBuff--;
    }
}



void SpiPutGetBuff( BYTE* pbSnd, BYTE* pbRcv, WORD cbSnd )
{
    while ( 0 < cbSnd ) {
        *pbRcv = BSpiPutByte(*pbSnd);
        pbRcv++;
        pbSnd++;
        cbSnd--;
    }
}

/************************************************************************/

void SpiClearScreen()
{
	SpiEnable();
	BSpiPutByte(27);
	DelayMs(40);
	BSpiPutByte('[');
	DelayMs(40);
	BSpiPutByte('*');
	DelayMs(40);
}

void Display_time(BYTE min1, BYTE min2, BYTE hr1,BYTE hr2)
{
	SpiClearScreen();;
	BSpiPutByte(hr2+48);
	DelayMs(40);
	BSpiPutByte(hr1+48);
	DelayMs(40);
	BSpiPutByte(':');
	DelayMs(40);
	BSpiPutByte(min2+48);
	DelayMs(40);
	BSpiPutByte(min1+48);
	DelayMs(40);
}